#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    uint32_t N, Q, L, R, res;

    cin >> N >> Q;

    uint32_t A[N], B[N];

    cin >> A[0];

    for(uint32_t i = 1; i < N; i++){
        cin >> A[i];

        A[i - 1] = A[i - 1] & A[i];
    }

    for( ; Q--;){
        cin >> L >> R;

        res = A[L - 1];

        for(uint32_t j = L; j < R - 1; j++){
            res &= A[j];
        }

        cout << res << "\n";
    }
}